#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

@interface AppDelegate : NSObject
@end
		
@implementation AppDelegate

/* Synthetizing a launch notification makes no sense here, but that's just an 
   example */
- (void) applicationDidFinishLaunching: (NSNotification *)not
{
	//[[NSDistributedNotificationCenter defaultCenter]
	[[[NSWorkspace sharedWorkspace] notificationCenter]
		addObserver: self
		   selector: @selector(noteApplicationLaunched:)
		       name: NSWorkspaceDidLaunchApplicationNotification
		     object: nil];

	NSDictionary *userInfo = [NSDictionary 
		dictionaryWithObjectsAndKeys: @"whateverPath", @"NSApplicationPath", 
		@"dummyName", @"NSApplicationName", nil]; 
	NSNotification *notif = [NSNotification
		notificationWithName: NSWorkspaceDidLaunchApplicationNotification
		object: self
		userInfo: userInfo];

	NSLog(@"Synthetize launch notification %@", notif);

	/* GSWorkspaceCenter subsitutes 'self' passed through 'object:' by 
	   GSWorkspaceNotification, so a string is passed to the distributed 
	   notification center as expected */
	[[[NSWorkspace sharedWorkspace] notificationCenter] postNotification: notif];
}

- (void) noteApplicationLaunched: (NSNotification *)notif
{
	NSLog(@"App launched: %@", notif);	
}

@end

int main(int argc, const char * argv[])
{
    CREATE_AUTORELEASE_POOL (pool);

	id appDelegate = [[AppDelegate alloc] init];
	[[NSApplication sharedApplication] setDelegate: appDelegate];
	[[NSApplication sharedApplication] run];

	DESTROY(appDelegate);
    DESTROY(pool);

    return 0;
}
